'---$DYNAMIC
'DEFINT A-Z

'DECLARE FUNCTION DQBinit (BYVAL NumLayers)
'DECLARE FUNCTION DQBemsSeg ()
'DECLARE FUNCTION DQBsetBit (BYVAL Value, BYVAL Bit)
'DECLARE FUNCTION DQBresetBit (BYVAL Value, BYVAL Bit)
'DECLARE FUNCTION DQBreadBit (BYVAL Value, BYVAL Bit)
'DECLARE FUNCTION DQBtoggleBit (BYVAL Value, BYVAL Bit)
'DECLARE FUNCTION DQBshiftLeft (BYVAL Value, BYVAL nBits)
'DECLARE FUNCTION DQBshiftRight (BYVAL Value, BYVAL nBits)
'DECLARE FUNCTION DQBpoint (BYVAL Layer, BYVAL x, BYVAL y)
'DECLARE FUNCTION DQBsize (BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2)
'DECLARE FUNCTION DQBloadLayer (Layer AS INTEGER, FileName AS STRING, Pal AS STRING)
'DECLARE FUNCTION DQBsaveLayer (Layer AS INTEGER, FileName AS STRING, Pal AS STRING, Format AS INTEGER)
'DECLARE FUNCTION DQBkey (BYVAL ScanCode)
'DECLARE FUNCTION DQBjoyDetected (BYVAL JoyNum)
'DECLARE FUNCTION DQBjoyMove (BYVAL JoyNum, BYVAL Direction)
'DECLARE FUNCTION DQBjoyFire (BYVAL JoyNum, BYVAL Button)
'DECLARE FUNCTION DQBmouseDetected ()
'DECLARE FUNCTION DQBmouseX ()
'DECLARE FUNCTION DQBmouseY ()
'DECLARE FUNCTION DQBmouseLB ()
'DECLARE FUNCTION DQBmouseRB ()
'DECLARE SUB DQBcopyLayer (BYVAL SourceLayer, BYVAL DestLayer)
'DECLARE SUB DQBcopyTransLayer (BYVAL SourceLayer, BYVAL DestLayer)
'DECLARE SUB DQBclearLayer (BYVAL Layer)
'DECLARE SUB DQBpset (BYVAL Layer, BYVAL x, BYVAL y, BYVAL Col)
'DECLARE SUB DQBline (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL Col)
'DECLARE SUB DQBbox (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL Col)
'DECLARE SUB DQBboxf (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL Col)
'DECLARE SUB DQBscroll (BYVAL Layer, BYVAL dx, BYVAL dy)
'DECLARE SUB DQBwait (BYVAL Times)
'DECLARE SUB DQBsetTransPut ()
'DECLARE SUB DQBsetSolidPut ()
'DECLARE SUB DQBsetClipBox (BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2)
'DECLARE SUB DQBget (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL BufSeg, BYVAL BufOff)
'DECLARE SUB DQBput (BYVAL Layer, BYVAL x, BYVAL y, BYVAL BufSeg, BYVAL BufOff)
'DECLARE SUB DQBsetCol (BYVAL ColorIndex, BYVAL Red, BYVAL Green, BYVAL Blue)
'DECLARE SUB DQBgetCol (BYVAL ColorIndex, Red, Green, Blue)
'DECLARE SUB DQBsetPal (Pal AS STRING)
'DECLARE SUB DQBgetPal (Pal AS STRING)
'DECLARE SUB DQBfadeIn (Pal AS STRING)
'DECLARE SUB DQBfadeTo (BYVAL Red, BYVAL Green, BYVAL Blue)
'DECLARE SUB DQBpalOff ()
'DECLARE SUB DQBprint (Layer AS INTEGER, Text AS STRING, x AS INTEGER, y AS INTEGER, Col AS INTEGER)
'DECLARE SUB DQBsetBIOSfont ()
'DECLARE SUB DQBsetFont (Font AS STRING)
'DECLARE SUB DQBsetTransText ()
'DECLARE SUB DQBsetSolidText ()
'DECLARE SUB DQBsetTextBackCol (BYVAL Col)
'DECLARE SUB DQBinstallKeyboard ()
'DECLARE SUB DQBremoveKeyboard ()
'DECLARE SUB DQBpollJoy (BYVAL JoyNum)
'DECLARE SUB DQBresetJoy ()
'DECLARE SUB DQBmouseShow ()
'DECLARE SUB DQBmouseHide ()
'DECLARE SUB DQBsetMouseRange (BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2)
'DECLARE SUB DQBsetMouseShape (hotX AS INTEGER, hotY AS INTEGER, Shape AS STRING)
'DECLARE SUB DQBresetMouse ()
'DECLARE SUB DQBclose ()




DEFINT A-Z
'$DYNAMIC
'$INCLUDE: 'MAZERPG.BI'

CLEAR , , 4096

OPEN "crashdet.$$$" FOR OUTPUT AS #1
CLOSE
LOADNEW% = 0
playerpic% = 1

ON ERROR GOTO ERRHAND


'DIM SHARED MIDI.PLAYTIME AS SINGLE
'DIM SHARED MIDI.ERROR AS INTEGER
'DIM SHARED MIDI.LOADED AS INTEGER
'DIM SHARED SBMIDI.INTERRUPT AS INTEGER
'DIM SHARED SBSIM.INTERRUPT AS INTEGER
'DIM SHARED SOUNDS%
'DIM SHARED SBS%
MIDI.PLAYTIME = 0
MIDI.ERROR = 0
MIDI.LOADED = 0

'SBMIDI.INTERRUPT = &H80
'SBSIM.INTERRUPT = &H81


ISGOOD% = DQBinit(2, 0)
DIM SHARED kbcontrol%(128), kbmatrix%(128)

CLS
SOUNDS% = 1
SBS% = 1
moz% = 1
scrollspeed% = 3
startup$ = "startup.tlk"

OPEN "mazerpg.ini" FOR INPUT AS #1
LINE INPUT #1, x$
x = INSTR(x$, "=")
scrollspeed% = VAL(MID$(x$, x + 1))
LINE INPUT #1, x$
x = INSTR(x$, "=")
startup$ = LTRIM$(RTRIM$(MID$(x$, x + 1)))
LINE INPUT #1, x$
x = INSTR(x$, "=")
SOUNDS% = VAL(MID$(x$, x + 1))
LINE INPUT #1, x$
x = INSTR(x$, "=")
SBS% = VAL(MID$(x$, x + 1))
LINE INPUT #1, x$
x = INSTR(x$, "=")
moz% = VAL(MID$(x$, x + 1))
LINE INPUT #1, x$
x = INSTR(x$, "=")
GAMEFONT$ = (MID$(x$, x + 1))

CLOSE #1

'ScrollSpeed% = 2
'SOUNDS% = 1
'SBS% = 1
'moz% = 0
'GAMEFONT$ = "bios"


GAMEFONT$ = UCASE$(GAMEFONT$) + ".FNT"


'DIM Font AS STRING * 2048
'OPEN "DQBDEMO.FNT" FOR BINARY AS #1
'IF LOF(1) = 0 THEN ERROR 83
'IF LOF(1) <> 2048 THEN ERROR 84
'GET #1, , Font: CLOSE #1
'DQBsetFont Font




Deftile 1
DIM SHARED btile%(numblock%)
DIM SHARED htile%(numhurt%)
DIM SHARED utile%(numunder%)
Deftile 2


DriversLoaded SBMIDI.INTERRUPT, SBSIM.INTERRUPT

a$ = COMMAND$
a$ = LTRIM$(RTRIM$(a$))
FOR i% = 1 TO LEN(a$)
IF MID$(a$, i%, 1) <> " " THEN B$ = B$ + MID$(a$, i%, 1)
NEXT i%
B$ = B$ + "/"
FOR i% = 1 TO LEN(B$)
  IF MID$(B$, i%, 1) = "/" OR MID$(B$, i%, 1) = "-" THEN countarg% = countarg% + 1
 NEXT i%
countarg% = countarg% - 1
DIM holdarg$(countarg%)
temp% = 1
FOR q% = 1 TO countarg%
FOR i% = temp% TO LEN(B$)
IF MID$(B$, i%, 1) = "/" OR MID$(B$, i%, 1) = "-" THEN EXIT FOR
NEXT i%
a% = 0
FOR j% = i% + 1 TO LEN(B$)
IF MID$(B$, j%, 1) = "/" OR MID$(B$, j%, 1) = "-" THEN temp% = j%: EXIT FOR
a% = a% + 1
NEXT j%
holdarg$(q%) = MID$(B$, i% + 1, a%)
NEXT q%

FOR q% = 1 TO countarg%
IF holdarg$(q%) = "SKIP" THEN skip% = 1
IF holdarg$(q%) = "DEBUG" THEN DEBUG% = 1
IF holdarg$(q%) = "NS" THEN SOUNDS% = -1: SBS% = 0
NEXT q%



IF skip% = 0 THEN post    'Player Obvious Stupidity Test
         'make sure sbmidi is loaded and all files exist


IF SOUNDS% = 1 THEN MasterVolume 15, 15, 0



DIM SHARED tiles%(118 * 140)
DIM SHARED dot(1 TO 1) AS YellowDot
DIM SHARED talkevents(999) AS INTEGER
DIM SHARED wavarray(1 TO 1) AS STRING * 32767
DIM SHARED bluepal%(255)
DIM SHARED redpal%(255)
DEF SEG = VARSEG(bluepal%(0))
BLOAD "bluepal.psv", VARPTR(bluepal%(0))
DEF SEG
DEF SEG = VARSEG(redpal%(0))
BLOAD "redpal.psv", VARPTR(redpal%(0))
DEF SEG


CALL DQBclearLayer(1)
CALL DQBclearLayer(2)


RANDOMIZE TIMER
filesave = 0: allani% = 0
xend% = 6: xstart% = -6
yend% = 5: ystart% = -5



dot(1).curhit = 20: dot(1).maxhit = 20
dot(1).strth = 5: dot(1).accuracy = 2
dot(1).wisdom = 10: dot(1).luck = INT(RND * 10)
'DEBUG% = 0


SCREEN 13                               ' Change to VGA (320x200, 256 colors)
RANDOMIZE TIMER
DIM SHARED Pal(255, 2) AS STRING * 1      'Required


getpal

DQBinstallKeyboard

ppx% = 150
ppy% = 92
pmx% = 15
pmy% = 9
map$ = "SIGMA.MAP"

LoadGraphics



NewMap:

IF LOADNEW% = 1 THEN mozaic 1

OpenMap
REDIM SHARED map%(mapx%, mapy%)
REDIM SHARED totwarp(numwarp% + 10) AS warptype
REDIM SHARED tottalk(numtalk% + 10) AS talktype
REDIM SHARED totexit(numexit% + 10) AS exittype
REDIM SHARED totlay(numlay% + 10) AS overlay
REDIM SHARED totauto(numautotalk% + 10) AS autotalk
LoadMap




newmus:

IF NameMidi$ = "" THEN NameMidi$ = "SBH1.MID"
'REDIM SHARED MidiArray%(BytesRequired&(NameMidi$) \ 2)
REDIM SHARED MidiArray%(4000)
LoadMIDI NameMidi$, VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
IF SOUNDS% = 1 THEN PlayMIDI VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
a = INSTR(NameMidi$, CHR$(0))
NameMidi$ = MID$(NameMidi$, 1, a - 1)





IF LOADNEW% = 1 THEN pmx% = pmx2%
IF LOADNEW% = 1 THEN pmy% = pmy2%


IF LOADNEW% = 1 THEN drawscreen2: mozaic 2

'fade 5, 63, 10


IF moz% = 1 AND LOADNEW% = 0 THEN Fadeout 0, 0, 0, 1, 1, 0, 255
drawscreen

IF LOADNEW% = 0 THEN
IF startup$ <> "" THEN talk startup$, 1, 1
IF LOADNEW% = 1 THEN GOTO NewMap
END IF




LOADNEW% = 0
f1! = TIMER
DO
   checkforother
   IF DQBkey(1) THEN
      menu
   ELSEIF DQBkey(80) THEN
      playerpic% = 1
      CheckTileDown
      IF ifblocked% = 0 THEN scroll 2
      pmy% = pmy% + 1
      drawscreen
      checkforother
      IF LOADNEW% = 1 THEN GOTO NewMap
      'drawscreen
   ELSEIF DQBkey(77) THEN
      playerpic% = 3
      CheckTileRight
      IF ifblocked% = 0 THEN scroll 4
      pmx% = pmx% + 1
      drawscreen
      checkforother
      IF LOADNEW% = 1 THEN GOTO NewMap
      'drawscreen
   ELSEIF DQBkey(75) THEN
      playerpic% = 2
      CheckTileLeft
      IF ifblocked% = 0 THEN scroll 3
      pmx% = pmx% - 1
      drawscreen
      checkforother
      IF LOADNEW% = 1 THEN GOTO NewMap
      'drawscreen
   ELSEIF DQBkey(72) THEN
      playerpic% = 4
      CheckTileUp
      IF ifblocked% = 0 THEN scroll 1
      pmy% = pmy% - 1
      drawscreen
      checkforother
      IF LOADNEW% = 1 THEN GOTO NewMap
      'drawscreen
  
   ELSEIF DQBkey(48) THEN
      filen$ = "pic" + MID$(STR$(filesave), 2, LEN(STR$(filesave))) + ".bsv"
      DEF SEG = &HA000
      BSAVE filen$, 0, 64000
      filesave = filesave + 1
   ELSEIF DQBkey(78) THEN
      scrollspeed% = scrollspeed% + 1
      delay 32000
   ELSEIF DQBkey(74) THEN
      scrollspeed% = scrollspeed% - 1
      IF scrollspeed% < 1 THEN scrollspeed% = 1
      delay 32000
   ELSEIF DQBkey(32) THEN
     DQBwait 3
    
     IF DEBUG% = 0 THEN
       DEBUG% = 1
       ELSE
       DEBUG% = 0
     END IF
  
   ELSEIF DQBkey(57) THEN
      FOR i% = 1 TO numtalk%
        IF tottalk(i%).dist = 4 THEN
         IF pmx% = tottalk(i%).x1 AND pmy% = tottalk(i%).y1 THEN
            talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
         ELSEIF pmx% = tottalk(i).x1 AND pmy% - 1 = tottalk(i).y1 THEN
            talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
         ELSEIF pmx% = tottalk(i).x1 AND pmy% + 1 = tottalk(i).y1 THEN
            talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
         ELSEIF pmx% + 1 = tottalk(i).x1 AND pmy% = tottalk(i).y1 THEN
            talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
         ELSEIF pmx% - 1 = tottalk(i).x1 AND pmy% = tottalk(i).y1 THEN
            talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
         END IF
        END IF
       
        IF tottalk(i%).dist = 0 THEN
         IF pmx% = tottalk(i%).x1 AND pmy% = tottalk(i%).y1 THEN talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
        END IF
       
        IF tottalk(i%).dist = 1 THEN
         IF pmx% = tottalk(i%).x1 AND pmy% - 1 = tottalk(i%).y1 THEN talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
        END IF
     
        IF tottalk(i%).dist = 5 THEN
         IF pmx% = tottalk(i%).x1 AND pmy% - 2 = tottalk(i%).y1 THEN talk tottalk(i%).filenm, tottalk(i%).x1, tottalk(i%).y1
        END IF


       IF LOADNEW% = 1 THEN GOTO NewMap
      NEXT i%
   ELSEIF DQBkey(45) THEN
      menu
   ELSEIF DQBkey(50) THEN
      IF SOUNDS% = 1 THEN
      RANDOMIZE TIMER
      NameMidi$ = "SBH" + MID$(STR$(INT(RND * 11) + 1), 2) + ".MID"
      LoadMIDI NameMidi$, VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
      IF SOUNDS% = 1 THEN PlayMIDI VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
      a = INSTR(NameMidi$, CHR$(0))
      NameMidi$ = MID$(NameMidi$, 1, a - 1)
      END IF

 

   ELSEIF DQBkey(11) THEN
   scrollspeed% = 15
  
   ELSEIF DQBkey(10) THEN
   CLS
   
   FOR ii% = 1 TO 20
   LOCATE ii%, 1
   PRINT talkevents(ii%)
   NEXT ii%
  
   FOR ii% = 21 TO 40
   LOCATE ii% - 20, 20
   PRINT talkevents(ii%)
   NEXT ii%

   SLEEP (2)

END IF

   drawscreen
   'checkforother
   'checkforanim
   IF SOUNDS% = 1 THEN CheckMidiTime

   IF dot(1).curhit = 0 THEN GOTO enditall

LOOP UNTIL DQBkey(16)


quickend:

DQBremoveKeyboard
IF SOUNDS% = 1 THEN StopMidi
END



ERRHAND:
SCREEN 0: WIDTH 80
COLOR 15
BEEP
IF ERDEV$ <> "" AND ERDEV <> 0 THEN
  PRINT "Error on device "; ERDEV$; " , device error code ="; ERDEV
  PRINT
END IF
PRINT "QBasic error code"; ERR
SELECT CASE ERR
  CASE 1: PRINT "NEXT without FOR"
  CASE 2: PRINT "Syntax error"
  CASE 3: PRINT "RETURN without GOSUB"
  CASE 4: PRINT "Out of DATA"
  CASE 5: PRINT "Illegal function call"
  CASE 6: PRINT "Overflow"
  CASE 7: PRINT "Out of memory"
  CASE 8: PRINT "Label not defined"
  CASE 9: PRINT "Subscript out of range"
  CASE 10: PRINT "Duplicate definition"
  CASE 11: PRINT "Division by zero"
  CASE 12: PRINT "Illegal in direct mode"
  CASE 13: PRINT "Type mismatch"
  CASE 14: PRINT "Out of string space"
  CASE 16: PRINT "String formula too complex"
  CASE 17: PRINT "Cannot continue"
  CASE 18: PRINT "Function not defined"
  CASE 19: PRINT "No RESUME"
  CASE 20: PRINT "RESUME without error"
  CASE 24: PRINT "Device timeout"
  CASE 25: PRINT "Device fault"
  CASE 26: PRINT "FOR without NEXT"
  CASE 27: PRINT "Out of paper"
  CASE 29: PRINT "WHILE without WEND"
  CASE 30: PRINT "WEND without WHILE"
  CASE 33: PRINT "Duplicate label"
  CASE 35: PRINT "Subprogram not defined"
  CASE 37: PRINT "Argument-count mismatch"
  CASE 38: PRINT "Array not defined"
  CASE 40: PRINT "Variable required"
  CASE 50: PRINT "FIELD overflow"
  CASE 51: PRINT "Internal error"
  CASE 52: PRINT "Bad file name or number"
  CASE 53: PRINT "File not found"
  CASE 54: PRINT "Bad file mode"
  CASE 55: PRINT "File already open"
  CASE 56: PRINT "FIELD statement activ"
  CASE 57: PRINT "Device I/O error"
  CASE 58: PRINT "File already exists"
  CASE 59: PRINT "Bad record length"
  CASE 61: PRINT "Disk full"
  CASE 62: PRINT "Input past end of file"
  CASE 63: PRINT "Bad record number"
  CASE 64: PRINT "Bad file name"
  CASE 67: PRINT "Too many files"
  CASE 68: PRINT "Device unavailable"
  CASE 69: PRINT "Communation-buffer overflow"
  CASE 70: PRINT "Permission denied"
  CASE 71: PRINT "Disk not ready"
  CASE 72: PRINT "Disk-media error"
  CASE 73: PRINT "Feature unavailable"
  CASE 74: PRINT "Rename across disks"
  CASE 75: PRINT "Path/File access error"
  CASE 76: PRINT "Path not found"
  CASE ELSE: PRINT "Unkown error"
END SELECT
IF ERL <> 0 THEN
  PRINT "Line"; ERL
END IF


enditall:
DQBremoveKeyboard
IF SOUNDS% = 1 THEN StopMidi
CALL DQBclose

END

'  ESC         01    U            22   | or \      43   F6          64
'  ! or 1      02    I            23   Z           44   F7          65
'  @ or 2      03    O            24   X           45   F8          66
'  # or 3      04    P            25   C           46   F9          67
'  $ or 4      05    { or [       26   V           47   F10         68
'  % or 5      06    } or ]       27   B           48   NUMLOCK     69
'  ^ or 6      07    ENTER        28   N           49   SCROLL LOCK 70
'  & or 7      08    CTRL         29   M           50   HOME or 7   71
'  * or 8      09    A            30   < or ,      51   UP or 8     72
'  ( or 9      10    S            31   > or .      52   PGUP or 9   73
'  ) or 0      11    D            32   ? or /      53   -           74
'  _ or -      12    F            33   RIGHT SHIFT 54   LEFT or 4   75
'  + or =      13    G            34   PRTSC or *  55   5           76
'  LEFT        14    H            35   ALT         56   RIGHT or 6  77
'  TAB         15    J            36   SPACEBAR    57   +           78
'  Q           16    K            37   CAPSLOCK    58   END or 1    79
'  W           17    L            38   F1          59   DOWN or 2   80
'  E           18    : or ;       39   F2          60   PGDN or 3   81
'  R           19    " or '       40   F3          61   INS or 0    82
'  T           20      or `       41   F4          62   DEL or .    83
'  Y           21    LEFT SHIFT   42   F5          63
   

findfile:
DATA 49
DATA "BACKGRND.BSV"
DATA "BLUEPAL.PSV"
DATA "CHEST.TLK"
DATA "CLICK.VOC"
DATA "CLOSEBOX.VOC"
DATA "DOOR.VOC"
DATA "ENTERBOX.VOC"
DATA "FLC.EXE"
DATA "GUN.PUT"
DATA "MAZERPG.INI"
DATA "OPENBOX.VOC"
DATA "OPENVIL.TLK"
DATA "OW.VOC"
DATA "READTXT.EXE"
DATA "REDPAL.PSV"
DATA "SBH1.MID"
DATA "SBH2.MID"
DATA "SBH3.MID"
DATA "SBH4.MID"
DATA "SBH5.MID"
DATA "SBH6.MID"
DATA "SBH7.MID"
DATA "SBH8.MID"
DATA "SBH9.MID"
DATA "SEESTONE.TLK"
DATA "SETUP.EXE"
DATA "SHELF.TLK"
DATA "SIGMA.MAP"
DATA "SIGMAII.MAP"
DATA "STAFF.TLK"
DATA "STAFMRK.TLK"
DATA "STARTUP.TLK"
DATA "STOP.TLK"
DATA "SUNLOGO.FLI"
DATA "TILES.DEF"
DATA "TMJ.TLK"
DATA "VILL.MAP"
DATA "VILL.TLK"
DATA "VILLAGE.MAP"
DATA "WIZ.TLK"
DATA "WOOSH.VOC"
DATA "WOS.TLK"
DATA "GUARDS.TLK"
DATA "LEADER.TLK"
DATA "SBH10.MID"
DATA "SBH11.MID"
DATA "MAZERPG.FNT"
DATA "SHIP.FLI"
DATA "TILE1.BSV"
'DATA "sigmaii.map", "sbmidi.exe", "tile1.bsv", "sbh1.mid", "sbh2.mid"
'DATA "sbh3.mid", "sbh4.mid","sbh5.mid","sbh6.mid", "woosh.voc", "mazerpg.ini"
'DATA "openbox.voc", "closebox.voc", "enterbox.voc"
'DATA "mazerpg.bat", "mazerpg.txt", "wiz.tlk", "credits.exe", "startup.tlk"
'DATA "staff.tlk", "stafmrk.tlk", "sigma.map", "play.exe", "sunlogo.fli"
'DATA "wos.tlk", "tmj.tlk", "mazerpg.ini", "stop.tlk", "village.map"
'DATA "alchston.tlk", "openvil.tlk", "seestone.tlk", "tiles.def"
'DATA "bluepal.psv", "redpal.psv"

REM $STATIC
DEFSNG A-Z
FUNCTION block% (tile%)
'CONST player = 1, playerm = 2, grass = 3, tree = 4, water = 5, brick = 6
'CONST brdoor = 7, brwindow = 8, brshingle = 9, ship = 10, flower = 11

IF DEBUG% = 0 THEN
FOR i% = 1 TO numblock%
IF tile% = btile%(i%) THEN block% = 1
NEXT i%
END IF

'IF a = 31 OR a = 5 OR a = 6 OR a = 8 THEN block% = 1
'IF a = 12 OR a = 13 OR a = 14 OR a = 15 OR a = 16 OR a = 17 THEN block% = 1
'IF a = 18 OR a = 19 OR a = 20 OR a = 21 OR a = 22 OR a = 25 THEN block% = 1
'IF a = 26 OR a = 33 OR a = 35 OR a = 36 THEN block% = 1
'IF a = 40 OR a = 41 OR a = 42 OR a = 49 OR a = 52 THEN block% = 1


'IF (pmx% + 2) + xend% > mapx% THEN block% = 1
'IF (pmx% - 2) - xend% < 1 THEN block% = 1
'IF (pmy% + 2) + yend% > mapy% THEN block% = 1
'IF (pmy% - 2) - yend% < 1 THEN block% = 1




'IF a = 20 THEN
'   drawscreen2
'   BlastBox VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 60, 10, 254, 174, 4, 1
'   BlastCopy VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), &HA000, 0
'   dot(1).curhit = dot(1).curhit - 1 ' : IF dot(1).curhit < 0 THEN dot(1).curhit = 0
'   delay 15000
'   drawscreen
'END IF

FOR i% = 1 TO numhurt%
IF tile% = htile%(i%) THEN
'   drawscreen2
'   BlastBox VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 60, 10, 254, 174, 4, 1
'   BlastCopy VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), &HA000, 0
   dot(1).curhit = dot(1).curhit - 1 ' : IF dot(1).curhit < 0 THEN dot(1).curhit = 0
drawscreen

IF SBS% = 1 THEN wavplay "ow.voc"
IF moz% = 1 THEN Fadeout 63, 0, 0, 4, 1, 0, 255
IF moz% = 1 THEN FadeIn 63, 0, 0, 4, 1, 0, 255



END IF
NEXT i%



END FUNCTION

SUB checkforother

FOR i% = 1 TO numwarp%
   IF pmx% = totwarp(i%).x1 AND pmy% = totwarp(i%).y1 THEN
  



        
       
 IF moz% = 1 AND totwarp(i%).sfx = 1 THEN
        FOR kk% = 1 TO 130 STEP 5
        drawscreen2
        DQBsetClipBox 60, 17, 254, 181
        FOR kkk% = 1 TO kk%
        BCircle 157, 98, 130 - kkk%, 0, 300, 200
        BCircle 158, 98, 130 - kkk%, 0, 300, 200
        IF DQBkey(1) THEN EXIT FOR
        NEXT kkk%
        DQBsetClipBox 0, 0, 319, 199
        IF ifunder%(map%(pmx%, pmy%)) <> 1 THEN
        CALL DQBput(1, ppx%, ppy%, VARSEG(tiles%(0)), VARPTR(tiles%(playerpic% * offsets%)))
        END IF
       
        CALL DQBcopyLayer(1, VIDEO)
       
        IF DQBkey(1) THEN EXIT FOR
       
        NEXT kk%
END IF
    
IF moz% = 1 AND totwarp(i%).sfx = 2 THEN
Fadeout 0, 0, 0, 20, 15, 0, 255
END IF


      IF SBS% = 1 THEN wavplay "door.voc"
      pmx% = totwarp(i%).x2: pmy% = totwarp(i%).y2
      
IF moz% = 1 AND totwarp(i%).sfx = 2 THEN
drawscreen
FadeIn 0, 0, 0, 20, 15, 0, 255
END IF

     

      

IF moz% = 1 AND totwarp(i%).sfx = 1 THEN
        FOR kk% = 1 TO 120 STEP 5
         drawscreen2
           DQBsetClipBox 60, 17, 254, 181
           FOR kkk% = kk% TO 120
           ktk% = kkk%
            CALL BCircle(157, 98, ktk%, 0, 300, 200)
            ktk% = kkk%
            CALL BCircle(158, 98, ktk%, 0, 300, 200)
            IF DQBkey(1) THEN EXIT FOR
            NEXT kkk%
            DQBsetClipBox 0, 0, 319, 199
            IF ifunder%(map%(pmx%, pmy%)) <> 1 THEN
            CALL DQBput(1, ppx%, ppy%, VARSEG(tiles%(0)), VARPTR(tiles%(playerpic% * offsets%)))
            END IF
        
         CALL DQBcopyLayer(1, VIDEO)
         NEXT kk%
        
  
   END IF
END IF
NEXT i%

FOR i% = 1 TO numexit%
   IF pmx% = totexit(i%).x1 AND pmy% = totexit(i%).y1 THEN
      map$ = totexit(i%).filenm
      pmx2% = totexit(i%).x2
      pmy2% = totexit(i%).y2
      MapFX% = totexit(i%).fx
      LOADNEW% = 1
      'StopMidi
      
   END IF
NEXT i%

FOR i% = 1 TO numautotalk%
   IF pmx% = totauto(i%).x AND pmy% = totauto(i%).y THEN
      filer$ = totauto(i%).filen
      talk filer$, pmx%, pmy%
   END IF
NEXT i%

END SUB

SUB CheckMidiTime
IF SOUNDS% = 1 THEN
   Miditimes! = TimeMIDI
   restarttime = 40
   IF NameMidi$ = "SBH1.MID" THEN restarttime = 47
   IF NameMidi$ = "SBH2.MID" THEN restarttime = 51
   IF NameMidi$ = "SBH3.MID" THEN restarttime = 38
   IF NameMidi$ = "SBH4.MID" THEN restarttime = 51
   IF NameMidi$ = "SBH5.MID" THEN restarttime = 95
   IF NameMidi$ = "SBH6.MID" THEN restarttime = 72
   IF NameMidi$ = "SBH7.MID" THEN restarttime = 181
   IF NameMidi$ = "SBH8.MID" THEN restarttime = 181
   IF NameMidi$ = "SBH9.MID" THEN restarttime = 93
   IF NameMidi$ = "SBH10.MID" THEN restarttime = 42
   IF NameMidi$ = "SBH11.MID" THEN restarttime = 62
   IF INT(Miditimes!) >= restarttime THEN
      StopMidi
      PlayMIDI VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
      Miditimes! = 0
   END IF
END IF

END SUB

SUB CheckTileDown
ifblocked% = 0

tile% = map%(pmx%, pmy%)                    ' Gets the number of the tile the

FOR i% = 1 TO numlay%
   IF (pmy% + 1 = totlay(i%).y) AND (pmx% = totlay(i%).x) AND (totlay(i%).block = 1) THEN
      pmy% = pmy% - 1
      ifblocked% = 1
   ELSEIF (pmy% + 1 = totlay(i%).y) AND (pmx% = totlay(i%).x) AND (totlay(i%).block = 0) THEN
      ifblocked% = 0
      GOTO after2
   END IF
NEXT i%

tile2% = map%(pmx%, pmy% + 1)
IF block%(tile2%) = 1 THEN pmy% = pmy% - 1: ifblocked% = 1

after2:

'DIM holder(10000)
'GET (60, 10)-(255, 175), holder
'FOR i = 1 TO 15
'PUT (60, 10 + i), holder, PSET
'NEXT i

'IF pmx% + xend% > mapx% THEN pmx% = pmx% - 1
'IF pmx% - xend% < 1 THEN pmx% = pmx% + 1
IF pmy% + 1 + yend% > mapy% THEN pmy% = pmy% - 1
'IF pmy% - yend% < 1 THEN pmy% = pmy% + 1


END SUB

SUB CheckTileLeft
ifblocked% = 0
tile% = map%(pmx%, pmy%)                    ' Gets the number of the tile the

FOR i% = 1 TO numlay%
   IF (pmy% = totlay(i%).y) AND (pmx% - 1 = totlay(i%).x) AND (totlay(i%).block = 1) THEN
      pmx% = pmx% + 1
      ifblocked% = 1
   ELSEIF (pmy% = totlay(i%).y) AND (pmx% - 1 = totlay(i%).x) AND (totlay(i%).block = 0) THEN
      ifblocked% = 0
      GOTO after1
   END IF
NEXT i%

tile2% = map%(pmx% - 1, pmy%)
IF block%(tile2%) = 1 THEN pmx% = pmx% + 1: ifblocked% = 1

after1:
'IF pmx% + xend% > mapx% THEN pmx% = pmx% - 1
IF pmx% - 1 - xend% < 1 THEN pmx% = pmx% + 1
'IF pmy% + yend% > mapy% THEN pmy% = pmy% - 1
'IF pmy% - yend% < 1 THEN pmy% = pmy% + 1

END SUB

SUB CheckTileRight
ifblocked% = 0
tile% = map%(pmx%, pmy%)                    ' Gets the number of the tile the

FOR i% = 1 TO numlay%
   IF (pmy% = totlay(i%).y) AND (pmx% + 1 = totlay(i%).x) AND (totlay(i%).block = 1) THEN
      pmx% = pmx% - 1
      ifblocked% = 1
   ELSEIF (pmy% = totlay(i%).y) AND (pmx% + 1 = totlay(i%).x) AND (totlay(i%).block = 0) THEN
      ifblocked% = 0
      GOTO after3
   END IF
NEXT i%

tile2% = map%(pmx% + 1, pmy%)
IF block%(tile2%) = 1 THEN pmx% = pmx% - 1: ifblocked% = 1

after3:
IF pmx% + 1 + xend% > mapx% THEN pmx% = pmx% - 1
'IF pmx% - xend% < 1 THEN pmx% = pmx% + 1
'IF pmy% + yend% > mapy% THEN pmy% = pmy% - 1
'IF pmy% - yend% < 1 THEN pmy% = pmy% + 1

END SUB

SUB CheckTileUp

ifblocked% = 0
tile% = map%(pmx%, pmy%)                    ' Gets the number of the tile the

FOR i% = 1 TO numlay%
   IF (pmy% - 1 = totlay(i%).y) AND (pmx% = totlay(i%).x) AND (totlay(i%).block = 1) THEN
      pmy% = pmy% + 1
      ifblocked% = 1
   ELSEIF (pmy% - 1 = totlay(i%).y) AND (pmx% = totlay(i%).x) AND (totlay(i%).block = 0) THEN
      ifblocked% = 0
      GOTO after4
   END IF
NEXT i%

tile2% = map%(pmx%, pmy% - 1)
IF block%(tile2%) = 1 THEN pmy% = pmy% + 1: ifblocked% = 1

after4:

'IF pmx% + xend% > mapx% THEN pmx% = pmx% - 1
'IF pmx% - xend% < 1 THEN pmx% = pmx% + 1
'IF pmy% + yend% > mapy% THEN pmy% = pmy% - 1
IF pmy% - 1 - yend% < 1 THEN pmy% = pmy% + 1

END SUB

DEFINT A-Z
SUB Deftile (sure%)

IF sure% = 1 THEN
OPEN "tiles.def" FOR INPUT AS #1
INPUT #1, numblock%
FOR i% = 1 TO numblock%
LINE INPUT #1, crap$
NEXT i%
INPUT #1, numhurt%
FOR i% = 1 TO numhurt%
LINE INPUT #1, crap$
NEXT i%
INPUT #1, numunder%

CLOSE #1

ELSE

OPEN "tiles.def" FOR INPUT AS #1
LINE INPUT #1, crap$

FOR i% = 1 TO numblock%
INPUT #1, t%
btile%(i%) = t%
NEXT i%

LINE INPUT #1, crap$

FOR i% = 1 TO numhurt%
INPUT #1, t%
htile%(i%) = t%
NEXT i%

LINE INPUT #1, crap$

FOR i% = 1 TO numunder%
INPUT #1, t%
utile%(i%) = t%
NEXT i%


END IF

CLOSE #1
END SUB

SUB delay (time%)

FOR hohoho% = 1 TO time%
NEXT hohoho%


END SUB

DEFSNG A-Z
SUB drawscreen


CALL DQBclearLayer(1)

a% = DQBloadLayer(1, "backgrnd.bsv", "")


'IF pmx% + xend% > mapx% THEN pmx% = pmx% - 1
'IF pmx% - xend% < 1 THEN pmx% = pmx% + 1
'IF pmy% + yend% > mapy% THEN pmy% = pmy% - 1
'IF pmy% - yend% < 1 THEN pmy% = pmy% + 1

FOR x% = xstart% TO xend%
   FOR y% = ystart% TO yend%
      tile% = map%(pmx% + x%, pmy% + y%)
      spotx% = ppx% + x% * 15
      spoty% = ppy% + y% * 15
     
      IF tile% = 20 THEN
            IF allani% >= 0 AND allani% < 10 THEN tile% = 20
            IF allani% >= 10 AND allani% < 20 THEN tile% = 21
            IF allani% >= 20 THEN tile% = 22
      END IF
      
      IF tile% = 64 THEN
            IF allani% >= 0 AND allani% < 10 THEN tile% = 64
            IF allani% >= 10 AND allani% < 20 THEN tile% = 65
            IF allani% >= 20 THEN tile% = 66
      END IF
      
      IF tile% = 87 THEN
            IF allani% >= 0 AND allani% < 15 THEN tile% = 87
            IF allani% >= 15 AND allani% < 30 THEN tile% = 88
      END IF

     
      IF tile% = 86 OR tile% = 87 OR tile% = 64 OR tile% = 65 OR tile% = 66 OR tile% = 20 OR tile% = 21 OR tile% = 22 THEN CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(tile% * offsets%)))
      CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(tile% * offsets%)))
      FOR i% = 1 TO numlay%
         IF (pmx% + x% = totlay(i%).x) AND (pmy% + y% = totlay(i%).y) THEN CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(totlay(i%).tile * offsets%)))
       NEXT i%
   NEXT y%
NEXT x%

allani% = allani% + 1

IF allani% > 30 THEN allani% = 0




IF ifunder%(map%(pmx%, pmy%)) <> 1 THEN
   CALL DQBput(1, ppx%, ppy%, VARSEG(tiles%(0)), VARPTR(tiles%(playerpic% * offsets%)))
END IF






CALL DQBbox(1, 57, 14, 257, 184, 30)
CALL DQBbox(1, 58, 15, 256, 183, 28)
CALL DQBbox(1, 59, 16, 255, 182, 26)

locatorst$ = STR$(pmx%) + " " + STR$(pmy%) + STR$(map%(pmx%, pmy%)) + STR$(scrollspeed%)
bprint 1, locatorst$, 1, 1, 15, 0, 1
bprint 1, townname$, 120, 1, 15, 25, 0
'BlastPrint VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 1, 1, locatorst$, 15
'BlastPrint VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 120, 1, townname$, 15




IF DEBUG% = 1 THEN DQBprint 1, "D", 1, 100, 15



CALL DQBcopyLayer(1, VIDEO)



END SUB

DEFINT A-Z
SUB drawscreen2

CALL DQBclearLayer(1)

a% = DQBloadLayer(1, "backgrnd.bsv", "")


FOR x% = xstart% TO xend%
   FOR y% = ystart% TO yend%
      tile% = map%(pmx% + x%, pmy% + y%)
      spotx% = ppx% + x% * 15
      spoty% = ppy% + y% * 15
    
      IF tile% = 20 THEN
            IF allani% >= 0 AND allani% < 10 THEN tile% = 20
            IF allani% >= 10 AND allani% < 20 THEN tile% = 21
            IF allani% >= 20 THEN tile% = 22
      END IF

      IF tile% = 64 THEN
            IF allani% >= 0 AND allani% < 10 THEN tile% = 64
            IF allani% >= 10 AND allani% < 20 THEN tile% = 65
            IF allani% >= 20 THEN tile% = 66
      END IF

      IF tile% = 87 THEN
            IF allani% >= 0 AND allani% < 15 THEN tile% = 87
            IF allani% >= 15 AND allani% < 30 THEN tile% = 88
      END IF
    
    
      IF tile% = 64 OR tile% = 65 OR tile% = 66 OR tile% = 20 OR tile% = 21 OR tile% = 22 THEN CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(tile% * offsets%)))
      CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(tile% * offsets%)))
      FOR i% = 1 TO numlay%
         IF (pmx% + x% = totlay(i%).x) AND (pmy% + y% = totlay(i%).y) THEN CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(totlay(i%).tile * offsets%)))
       NEXT i%
   NEXT y%
NEXT x%

'allani% = allani% + 2

IF allani% > 30 THEN allani% = 0


IF ifunder%(map%(pmx%, pmy%)) <> 1 THEN
   CALL DQBput(1, ppx%, ppy%, VARSEG(tiles%(0)), VARPTR(tiles%(playerpic% * offsets%)))
END IF







CALL DQBbox(1, 57, 14, 257, 184, 30)
CALL DQBbox(1, 58, 15, 256, 183, 28)
CALL DQBbox(1, 59, 16, 255, 182, 26)


locatorst$ = STR$(pmx%) + " " + STR$(pmy%) + STR$(map%(pmx%, pmy%)) + STR$(scrollspeed%)
bprint 1, locatorst$, 1, 1, 15, 0, 1
bprint 1, townname$, 120, 1, 15, 25, 0
'BlastPrint VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 1, 1, locatorst$, 15
'BlastPrint VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 120, 1, townname$, 15




IF DEBUG% = 1 THEN DQBprint 1, "D", 1, 100, 15





END SUB

DEFSNG A-Z
FUNCTION ifbehind

FOR i% = 1 TO numunder%
IF map%(pmx%, pmy%) = utile%(i%) THEN ifbehind = 1
NEXT i%


END FUNCTION

FUNCTION ifunder% (a%)
FOR i% = 1 TO numunder%
IF a% = utile%(i%) THEN ifunder% = 1
NEXT i%


END FUNCTION

SUB LoadGraphics


FOR i% = 0 TO 255
   OUT &H3C8, i%
   OUT &H3C9, 0
   OUT &H3C9, 0
   OUT &H3C9, 0
NEXT i%

CLS                                     ' Clear the screen.
LINE (1, 1)-(15, 15), 255, BF
CALL DQBget(VIDEO, 1, 1, 15, 15, VARSEG(tiles%(0)), VARPTR(tiles%(0)))
DEF SEG = &HA000
BLOAD "tile1.bsv", 0
DEF SEG


xq% = 1
FOR i% = 1 TO 19
xq2% = xq% + 14
CALL DQBget(VIDEO, xq%, 1, xq2%, 15, VARSEG(tiles%(0)), VARPTR(tiles%(i% * offsets%)))
xq% = xq% + 15
NEXT i%

xq% = 1
FOR i% = 20 TO 38
xq2% = xq% + 14
CALL DQBget(VIDEO, xq%, 16, xq2%, 30, VARSEG(tiles%(0)), VARPTR(tiles%(i% * offsets%)))
xq% = xq% + 15
NEXT i%

xq% = 1
FOR i% = 39 TO 57
xq2% = xq% + 14
CALL DQBget(VIDEO, xq%, 31, xq2%, 45, VARSEG(tiles%(0)), VARPTR(tiles%(i% * offsets%)))
xq% = xq% + 15
NEXT i%


xq% = 1
FOR i% = 58 TO 76
xq2% = xq% + 14
CALL DQBget(VIDEO, xq%, 46, xq2%, 60, VARSEG(tiles%(0)), VARPTR(tiles%(i% * offsets%)))
xq% = xq% + 15
NEXT i%


xq% = 1
FOR i% = 77 TO 95
xq2% = xq% + 14
CALL DQBget(VIDEO, xq%, 61, xq2%, 75, VARSEG(tiles%(0)), VARPTR(tiles%(i% * offsets%)))
xq% = xq% + 15
NEXT i%

xq% = 1
FOR i% = 96 TO 105
xq2% = xq% + 14
CALL DQBget(VIDEO, xq%, 76, xq2%, 90, VARSEG(tiles%(0)), VARPTR(tiles%(i% * offsets%)))
xq% = xq% + 15
NEXT i%





CLS                                     ' Clear the screen.





CLS
PALETTE

END SUB

SUB LoadMap

OPEN map$ FOR INPUT AS #1
LINE INPUT #1, FF$
LINE INPUT #1, FF$

FOR y% = 1 TO mapy%                       ' For y equals 1 to the maps vertical
                                          ' number of tiles.
   FOR x% = 1 TO mapx%                       ' For x equals 1 to the maps
      INPUT #1, k%
      map%(x%, y%) = k%
   NEXT x%
NEXT y%

LINE INPUT #1, crap$
FOR i% = 1 TO numwarp%
   LINE INPUT #1, x$
   totwarp(i%).x1 = VAL(MID$(x$, 1, 3))
   totwarp(i%).y1 = VAL(MID$(x$, 5, 3))
   totwarp(i%).x2 = VAL(MID$(x$, 9, 3))
   totwarp(i%).y2 = VAL(MID$(x$, 13, 3))
   totwarp(i%).sfx = VAL(MID$(x$, 17, 1))
NEXT i%

LINE INPUT #1, crap$

FOR i% = 1 TO numtalk%
   LINE INPUT #1, x$
   tottalk(i%).x1 = VAL(MID$(x$, 1, 3))
   tottalk(i%).y1 = VAL(MID$(x$, 5, 3))
   tottalk(i%).dist = VAL(MID$(x$, 9, 1))
   tottalk(i%).filenm = MID$(x$, 11)
NEXT i%

LINE INPUT #1, crap$

FOR i% = 1 TO numexit%
   LINE INPUT #1, x$
   totexit(i%).x1 = VAL(MID$(x$, 1, 3))
   totexit(i%).y1 = VAL(MID$(x$, 5, 3))
   totexit(i%).x2 = VAL(MID$(x$, 9, 3))
   totexit(i%).y2 = VAL(MID$(x$, 13, 3))
   totexit(i%).fx = VAL(MID$(x$, 17, 1))
   totexit(i%).filenm = MID$(x$, 19)
NEXT i%

LINE INPUT #1, crap$

FOR i% = 1 TO numlay%
   LINE INPUT #1, x$
   totlay(i%).x = VAL(MID$(x$, 1, 3))
   totlay(i%).y = VAL(MID$(x$, 5, 3))
   totlay(i%).tile = VAL(MID$(x$, 9, 3))
   totlay(i%).block = VAL(MID$(x$, 13))
NEXT i%

LINE INPUT #1, crap$

FOR i% = 1 TO numautotalk%
   LINE INPUT #1, x$
   totauto(i%).x = VAL(MID$(x$, 1, 3))
   totauto(i%).y = VAL(MID$(x$, 5, 3))
   totauto(i%).filen = MID$(x$, 9)
NEXT i%

LINE INPUT #1, NameMidi$

CLOSE #1
END SUB

DEFINT A-Z
SUB menu

'DIM holder%(1662)

'DEF SEG = VARSEG(holder%(0))
'BLOAD "gun.put", VARPTR(holder%(0))
'DEF SEG
'holder%(0) = holder%(0) / 8




cc% = 15
FOR i% = 0 TO 90 STEP 5
   drawscreen2
   CALL DQBboxf(1, 160 - i% * 7 \ 5, 100 - i%, 160 + i% * 7 \ 5, 100 + i%, 1)
   CALL DQBbox(1, 159 - i% * 7 \ 5, 99 - i%, 161 + i% * 7 \ 5, 101 + i%, 30)
   CALL DQBbox(1, 158 - i% * 7 \ 5, 98 - i%, 162 + i% * 7 \ 5, 102 + i%, 27)
   CALL DQBbox(1, 157 - i% * 7 \ 5, 97 - i%, 163 + i% * 7 \ 5, 103 + i%, 23)
   CALL DQBwait(1)
   CALL DQBcopyLayer(1, VIDEO)
   cc% = cc% - 1
IF cc% < 0 THEN cc% = 0
IF SOUNDS% = 1 THEN MasterVolume cc%, cc%, 0
NEXT i%

CALL DQBboxf(1, 34, 10, 286, 190, 1)
CALL DQBbox(1, 33, 9, 287, 191, 30)
CALL DQBbox(1, 32, 8, 288, 192, 27)
CALL DQBbox(1, 31, 7, 289, 193, 23)

IF SOUNDS% = 1 THEN StopMidi
Oldmidi$ = NameMidi$
NameMidi$ = "SBH11.MID"
LoadMIDI NameMidi$, VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
IF SOUNDS% = 1 THEN PlayMIDI VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
a = INSTR(NameMidi$, CHR$(0))
NameMidi$ = MID$(NameMidi$, 1, a - 1)


CALL DQBcopyLayer(1, VIDEO)
MasterVolume 0, 0, 0
FOR cc% = 0 TO 30
IF SOUNDS% = 1 THEN MasterVolume cc% / 2, cc% / 2, 0
NEXT cc%
over% = 1



DO
   IF DQBkey(72) THEN
      IF SBS% = 1 THEN wavplay "click.voc"
      CALL DQBwait(6)
      over% = over% - 1
      IF over% = 0 THEN over% = 6
   ELSEIF DQBkey(80) THEN
      IF SBS% = 1 THEN wavplay "click.voc"
      CALL DQBwait(6)
      over% = over% + 1
      IF over% = 7 THEN over% = 1
   END IF

   CALL DQBcopyLayer(1, VIDEO)
  
   drawscreen2

CALL DQBboxf(1, 34, 10, 286, 190, 1)
CALL DQBbox(1, 33, 9, 287, 191, 30)
CALL DQBbox(1, 32, 8, 288, 192, 27)
CALL DQBbox(1, 31, 7, 289, 193, 23)

   IF over% = 1 THEN bprint 1, "EQUIP", 46, 21, 15, 22, 1 ELSE bprint 1, "EQUIP", 45, 20, 28, 22, 0
   IF over% = 2 THEN bprint 1, "CAST", 46, 31, 15, 22, 1 ELSE bprint 1, "CAST", 45, 30, 28, 22, 0
   IF over% = 3 THEN bprint 1, "ITEM", 46, 41, 15, 22, 1 ELSE bprint 1, "ITEM", 45, 40, 28, 22, 0
   IF over% = 4 THEN bprint 1, "OPTION", 46, 51, 15, 22, 1 ELSE bprint 1, "OPTION", 45, 50, 28, 22, 0
   IF over% = 5 THEN bprint 1, "LOAD", 46, 61, 15, 22, 1 ELSE bprint 1, "LOAD", 45, 60, 28, 22, 0
   IF over% = 6 THEN bprint 1, "QUIT", 46, 71, 15, 22, 1 ELSE bprint 1, "QUIT", 45, 70, 28, 22, 0

   bprint 1, "LIFEFORCE:", 130, 20, 15, 22, 0
   stringer$ = STR$((dot(1).curhit / dot(1).maxhit) * 100) + "%"
   bprint 1, stringer$, 210, 20, 15, 22, 1
  
   bprint 1, " STRENGTH:", 130, 30, 15, 22, 0
   stringer$ = STR$(dot(1).strth)
   bprint 1, stringer$, 210, 30, 15, 22, 1
  
   bprint 1, " ACCURACY:", 130, 40, 15, 22, 0
   stringer$ = STR$(dot(1).accuracy)
   bprint 1, stringer$, 210, 40, 15, 22, 1
  
   bprint 1, "   WISDOM:", 130, 50, 15, 22, 0
   stringer$ = STR$(dot(1).wisdom)
   bprint 1, stringer$, 210, 50, 15, 22, 1

   bprint 1, "     LUCK:", 130, 60, 15, 22, 0
   stringer$ = STR$(dot(1).luck)
   bprint 1, stringer$, 210, 60, 15, 22, 1

   'CALL DQBput(1, 60, 120, VARSEG(holder%(0)), VARPTR(holder%(0)))
  
   CALL DQBcopyLayer(1, VIDEO)

   IF DQBkey(28) THEN
      IF SBS% = 1 THEN wavplay "click.voc"
      DQBwait 10
     
      IF over% = 6 THEN
     
      IF SOUNDS% = 1 THEN
      FOR i% = 15 TO 0 STEP -1
      MasterVolume i%, i%, 0
      DQBwait 1
      NEXT i%
      END IF
     
      IF SOUNDS% = 1 THEN StopMidi
      NameMidi$ = "SBH9.MID"
      LoadMIDI NameMidi$, VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
      IF SOUNDS% = 1 THEN PlayMIDI VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
      a = INSTR(NameMidi$, CHR$(0))
      NameMidi$ = MID$(NameMidi$, 1, a - 1)
      credits
      
     
      ELSEIF over% = 4 THEN
   option2% = 1
   DO
   CALL DQBboxf(1, 60, 40, 260, 160, 1)
   CALL DQBbox(1, 59, 39, 261, 161, 30)
   CALL DQBbox(1, 58, 38, 262, 162, 27)
   CALL DQBbox(1, 57, 37, 263, 163, 23)
   bprint 1, "OPTIONS", 130, 50, 15, 23, 0
   IF option2% = 1 THEN bprint 1, "MIDI      :", 80, 60, 15, 0, 1 ELSE bprint 1, "MIDI      :", 80, 60, 23, 0, 1
   IF option2% = 2 THEN bprint 1, "SB SOUND  :", 80, 70, 15, 0, 1 ELSE bprint 1, "SB SOUND  :", 80, 70, 23, 0, 1
   IF option2% = 3 THEN bprint 1, "SPECIAL FX:", 80, 80, 15, 0, 1 ELSE bprint 1, "SPECIAL FX:", 80, 80, 23, 0, 1
   IF SOUNDS% = 1 THEN
   bprint 1, "               ON", 80, 60, 2, 22, 0
   ELSEIF SOUNDS% = 0 THEN
   bprint 1, "               OFF", 80, 60, 4, 22, 0
   ELSEIF SOUNDS% = -1 THEN
   bprint 1, "             DISABLED", 80, 60, 28, 22, 0
   END IF
  
   IF SBS% = 1 THEN
   bprint 1, "               ON", 80, 70, 2, 22, 0
   ELSEIF SBS% = 0 THEN
   bprint 1, "               OFF", 80, 70, 4, 22, 0
   END IF

   IF moz% = 1 THEN
   bprint 1, "               ON", 80, 80, 2, 22, 0
   ELSEIF moz% = 0 THEN
   bprint 1, "               OFF", 80, 80, 4, 22, 0
   END IF
   CALL DQBcopyLayer(1, VIDEO)
  
   IF DQBkey(72) THEN
      IF SBS% = 1 THEN wavplay "click.voc"
      CALL DQBwait(6)
      option2% = option2% - 1
      IF option2% < 1 THEN option2% = 3
   ELSEIF DQBkey(80) THEN
      IF SBS% = 1 THEN wavplay "click.voc"
      CALL DQBwait(6)
      option2% = option2% + 1
      IF option2% > 3 THEN option2% = 1
   END IF


   IF DQBkey(28) THEN
      IF SBS% = 1 THEN wavplay "click.voc"
      DQBwait 20
      
     
      IF option2% = 2 THEN
       IF SBS% = 1 THEN
         SBS% = 0
       ELSE
         SBS% = 1
       END IF
      ELSEIF option2% = 1 THEN
       IF SOUNDS% <> -1 THEN
       IF SOUNDS% = 1 THEN
         StopMidi
         SOUNDS% = 0
        ELSE
         SOUNDS% = 1
         IF SOUNDS% = 1 THEN PlayMIDI VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
       END IF
      END IF
      ELSEIF option2% = 3 THEN
       IF moz% = 1 THEN
         moz% = 0
       ELSE
         moz% = 1
       END IF
    END IF
   
   END IF
  


   LOOP UNTIL DQBkey(1)
     DQBwait 10
     
      END IF
   END IF

IF SOUNDS% = 1 THEN CheckMidiTime
LOOP UNTIL DQBkey(1)

FOR i% = 90 TO 0 STEP -5
   drawscreen2

   CALL DQBboxf(1, 160 - i% * 7 \ 5, 100 - i%, 160 + i% * 7 \ 5, 100 + i%, 1)
   CALL DQBbox(1, 159 - i% * 7 \ 5, 99 - i%, 161 + i% * 7 \ 5, 101 + i%, 30)
   CALL DQBbox(1, 158 - i% * 7 \ 5, 98 - i%, 162 + i% * 7 \ 5, 102 + i%, 27)
   CALL DQBbox(1, 157 - i% * 7 \ 5, 97 - i%, 163 + i% * 7 \ 5, 103 + i%, 23)
   CALL DQBwait(1)
   CALL DQBcopyLayer(1, VIDEO)
NEXT i%


NameMidi$ = Oldmidi$
LoadMIDI NameMidi$, VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
IF SOUNDS% = 1 THEN PlayMIDI VARSEG(MidiArray%(0)), VARPTR(MidiArray%(0))
a = INSTR(NameMidi$, CHR$(0))
NameMidi$ = MID$(NameMidi$, 1, a - 1)


drawscreen

END SUB

SUB mozaic (types%)


a% = DQBloadLayer(2, "backgrnd.bsv", "")


IF MapFX% = 1 THEN
IF types% = 1 AND moz% = 1 THEN

  
  
   FOR Siz% = 2 TO 12 STEP 1
     IF SOUNDS% = 1 THEN MasterVolume 15 - Siz%, 15 - Siz%, 0
      FOR ya% = 18 TO 181 STEP Siz%
         FOR xa% = 60 TO 254 STEP Siz%
            N% = DQBpoint(1, xa%, ya%)
            x1a% = xa% - (Siz \ 2): y1a% = ya% - (Siz% \ 2)
            x2a% = xa% + (Siz% - 1): y2a% = ya% + (Siz% - 1)
            IF x1a% < 60 THEN x1a% = 60
            IF y1a% < 17 THEN y1a% = 17
            IF x2a% > 254 THEN x2a% = 254
            IF y2a% > 181 THEN y2a% = 181
            CALL DQBboxf(0, x1a%, y1a%, x2a%, y2a%, N%)
            NEXT xa%
      NEXT ya%
'CALL DQBbox(2, 57, 14, 257, 184, 30)
'CALL DQBbox(2, 58, 15, 256, 183, 28)
'CALL DQBbox(2, 59, 16, 255, 182, 26)
DQBwait 4
      'CALL DQBcopyLayer(2, VIDEO)
   NEXT Siz%

ELSEIF types% = 2 AND moz% = 1 THEN
drawscreen2
   FOR Siz% = 12 TO 2 STEP -1
      IF SOUNDS% = 1 THEN MasterVolume 15 - Siz%, 15 - Siz%, 0
      FOR ya% = 18 TO 181 STEP Siz%
         FOR xa% = 60 TO 254 STEP Siz%
            N% = DQBpoint(1, xa%, ya%)
            x1a% = xa% - (Siz \ 2): y1a% = ya% - (Siz% \ 2)
            x2a% = xa% + (Siz% - 1): y2a% = ya% + (Siz% - 1)
            IF x1a% < 60 THEN x1a% = 60
            IF y1a% < 17 THEN y1a% = 17
            IF x2a% > 254 THEN x2a% = 254
            IF y2a% > 181 THEN y2a% = 181
            CALL DQBboxf(0, x1a%, y1a%, x2a%, y2a%, N%)
         NEXT xa%
      NEXT ya%
DQBwait 4
'CALL DQBbox(2, 57, 14, 257, 184, 30)
'CALL DQBbox(2, 58, 15, 256, 183, 28)
'CALL DQBbox(2, 59, 16, 255, 182, 26)
       
       ' CALL DQBcopyLayer(2, VIDEO)
   NEXT Siz%
IF SOUNDS% = 1 THEN MasterVolume 15, 15, 0
END IF

ELSEIF MapFX% = 2 THEN

IF types% = 1 THEN
Fadeout 63, 63, 63, 80, 80, 0, 255
END IF

IF types% = 2 THEN
drawscreen
FadeIn 63, 63, 63, 80, 80, 0, 255
END IF



END IF



END SUB

SUB opening
END SUB

DEFSNG A-Z
SUB OpenMap

OPEN map$ FOR INPUT AS #1
INPUT #1, townname$
INPUT #1, mapx%, mapy%

FOR i% = 1 TO mapy%
   LINE INPUT #1, crap$
NEXT i%

INPUT #1, numwarp%

FOR i% = 1 TO numwarp%
   LINE INPUT #1, crap$
NEXT i%

INPUT #1, numtalk%

FOR i% = 1 TO numtalk%
   LINE INPUT #1, crap$
NEXT i%

INPUT #1, numexit%

FOR i% = 1 TO numexit%
   LINE INPUT #1, crap$
NEXT i%

INPUT #1, numlay%

FOR i% = 1 TO numlay%
   LINE INPUT #1, crap$
NEXT i%

INPUT #1, numautotalk%

FOR i% = 1 TO numautotalk%
   LINE INPUT #1, crap$
NEXT i%

CLOSE #1

END SUB

SUB post
CLS
SCREEN 0: WIDTH 80
COLOR 4, 15
LOCATE 1, 1
PRINT STRING$(80, " ")
LOCATE 1, 28: PRINT "MAZERPG by 19DAY PRODUCTIONS"
COLOR 15, 0
LOCATE 3, 1
PRINT "CHECKING FOR SBMIDI PRESENCE..."
DriversLoaded SBMIDI.INTERRUPT, SBSIM.INTERRUPT
IF SBMIDI.INTERRUPT = 0 THEN
   COLOR 4
   PRINT "SBMIDI.EXE not loaded..."
   COLOR 15
   anerror = 1
ELSE
   PRINT "SBMIDI.EXE loaded..."
END IF

locas = 6

READ k%

FOR iii% = 1 TO k%
READ file$
COLOR 15
LOCATE locas, 1
PRINT "CHECKING: "
COLOR 14
LOCATE locas, 11
PRINT file$; SPACE$(14 - LEN(file$))


IF Exist%(file$, 0) = -1 THEN
LOCATE locas, 12 + LEN(file$)
COLOR 15
PRINT " ... FOUND!"; SPACE$(14)
ELSE
COLOR 4
LOCATE locas, 12 + LEN(file$)
PRINT "... NOT FOUND!"; SPACE$(14)
SLEEP (1)
ferror = 1
END IF
DQBwait 5
NEXT iii%

COLOR 15
PRINT

IF ferror = 0 THEN
PRINT "All files found...."
ELSEIF ferror = 1 THEN
   PRINT
   PRINT "You are missing nessesary files!"
   PRINT
   PRINT "The program will continue to run, but may"
   PRINT "lock up or experience another error during"
   PRINT "execution..."
   SLEEP (3)
   END IF





IF anerror = 1 THEN
   COLOR 4
   PRINT "You are missing the SBMIDI driver."
   PRINT "This will automatically disable sound."
   PRINT "If you want sound, exit and load the driver."
   COLOR 15
   SOUNDS% = -1
   SLEEP 3
   PRINT
END IF

PRINT
IF ISGOOD% <> 0 THEN
COLOR 4
PRINT "THE EMS GRAPHICAL ENGINE DID NOT LOAD AS PLANED!!!"
PRINT "THE CAUSE COULD BE FROM INSUFFICIENT EMS MEMORY,"
PRINT "OR A NON >=386 COMPUTER.  PLEASE SEE HELP FILE."
COLOR 15
SLEEP (3)
END
END IF

PRINT
SLEEP (3)
CLS
SLEEP 1
'SHELL "play -m1 sunlogo.fli >nul"
SHELL "flc sunlogo.fli /d /r=1 >nul"
COLOR 15
CLS
SLEEP 1
SHELL "flc ship.fli /d /r=1 /s=10 >nul"
CLS
SLEEP 1

END SUB

SUB scroll (direct)



FOR kkk% = 0 TO 14 STEP scrollspeed%
   CALL DQBclearLayer(1)
   a% = DQBloadLayer(1, "backgrnd.bsv", "")
  
   

   DQBsetClipBox 60, 17, 255, 182
'   IF pmx% + xend% > mapx% - 1 THEN pmx% = pmx% - 1
'   IF pmx% - xend% < 2 THEN pmx% = pmx% + 1
'   IF pmy% + yend% > mapy% - 1 THEN pmy% = pmy% - 1
'   IF pmy% - yend% < 2 THEN pmy% = pmy% + 1

   try1% = 0: try2% = 0: try3% = 0: try4% = 0

   IF direct = 1 THEN try4% = 1
   IF direct = 2 THEN try3% = 1
   IF direct = 3 THEN try2% = 1
   IF direct = 4 THEN try1% = 1

   FOR x% = xstart% - try2% TO xend% + try1%
      FOR y% = ystart% - try4% TO yend% + try3%
                              
         '1 = up
         '2 = down
         '3 = left
         '4 = right
         tile% = map%(pmx% + x%, pmy% + y%)

         spoty% = ppy% + y% * 15: spotx% = ppx% + x% * 15

         IF direct = 1 THEN
            spoty% = ppy% + y% * 15 + kkk%
         ELSEIF direct = 2 THEN
            spoty% = ppy% + y% * 15 - kkk%
         ELSEIF direct = 3 THEN
            spotx% = ppx% + x% * 15 + kkk%
         ELSEIF direct = 4 THEN
            spotx% = ppx% + x% * 15 - kkk%
         END IF
                      
         IF tile% = 20 THEN
            IF allani% >= 0 AND allani% < 8 THEN tile% = 20
            IF allani% >= 8 AND allani% < 16 THEN tile% = 21
            IF allani% >= 16 THEN tile% = 22
         END IF
     
      IF tile% = 64 THEN
            IF allani% >= 0 AND allani% < 10 THEN tile% = 64
            IF allani% >= 10 AND allani% < 20 THEN tile% = 65
            IF allani% >= 20 THEN tile% = 66
      END IF
     
      IF tile% = 87 THEN
            IF allani% >= 0 AND allani% < 15 THEN tile% = 87
            IF allani% >= 15 AND allani% < 30 THEN tile% = 88
      END IF
        
        
         IF tile% = 20 OR tile% = 21 OR tile% = 22 THEN CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(tile% * offsets%)))

         CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(tile% * offsets%)))
         

         FOR i% = 1 TO numlay%
           IF (pmx% + x% = totlay(i%).x) AND (pmy% + y% = totlay(i%).y) THEN CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(totlay(i%).tile * offsets%)))
         NEXT i%

      NEXT y%                                  ' Increase y by 1
   NEXT x%                                  ' Increase x by 1

  
  
  
   allani% = allani% + 2
   IF allani% > 20 THEN allani% = 0

   'IF noplayer = 1 THEN
   'ELSE
   IF noplayer <> 1 THEN
      adj% = 0
      IF kkk% < 5 THEN adj% = kkk%
      IF kkk% >= 5 AND kkk% <= 9 THEN adj% = 5
      IF kkk% > 9 THEN adj% = 15 - kkk%
     CALL DQBput(1, ppx%, ppy% - adj%, VARSEG(tiles%(0)), VARPTR(tiles%(playerpic% * offsets%)))
   
    'DQBscaledPut 1, ppx%, ppy% - adj%, VARSEG(tiles%(0)), VARPTR(tiles%(playerpic% * offsets%)), 20, 20
   END IF

   FOR x% = xstart% - try2% TO xend% + try1%
      FOR y% = ystart% - try4% TO yend% + try3%
         tile% = map%(pmx% + x%, pmy% + y%)
         spoty% = ppy% + y% * 15: spotx% = ppx% + x% * 15
         IF direct = 1 THEN
            spoty% = ppy% + y% * 15 + kkk%
         ELSEIF direct = 2 THEN
            spoty% = ppy% + y% * 15 - kkk%
         ELSEIF direct = 3 THEN
            spotx% = ppx% + x% * 15 + kkk%
         ELSEIF direct = 4 THEN
            spotx% = ppx% + x% * 15 - kkk%
         END IF

         IF ifunder(tile%) = 1 THEN CALL DQBput(1, spotx%, spoty%, VARSEG(tiles%(0)), VARPTR(tiles%(tile% * offsets%)))
      NEXT y%                                  ' Increase y by 1
   NEXT x%                                  ' Increase x by 1

DQBsetClipBox 0, 0, 319, 199


  



CALL DQBbox(1, 57, 14, 257, 184, 30)
CALL DQBbox(1, 58, 15, 256, 183, 28)
CALL DQBbox(1, 59, 16, 255, 182, 26)

CALL DQBwait(1)
   locatorst$ = STR$(pmx%) + " " + STR$(pmy%) + STR$(map%(pmx%, pmy%))
   bprint 1, locatorst$, 1, 1, 15, 0, 1
   bprint 1, townname$, 120, 1, 15, 25, 0
   'BlastPrint VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 1, 1, locatorst$, 15
   'BlastPrint VARSEG(buffer1%(0)), VARPTR(buffer1%(0)), 120, 1, townname$, 15

CALL DQBcopyLayer(1, VIDEO)





NEXT kkk%

DQBsetClipBox 0, 0, 319, 199

END SUB

