'THe mazeRPG include file

DEFINT A-Z
'$DYNAMIC

TYPE warptype
   x1 AS INTEGER
   x2 AS INTEGER
   y1 AS INTEGER
   y2 AS INTEGER
   Sfx AS INTEGER
END TYPE

TYPE talktype
   x1 AS INTEGER
   y1 AS INTEGER
   filenm AS STRING * 14
   dist AS INTEGER
END TYPE

TYPE exittype
   x1 AS INTEGER
   x2 AS INTEGER
   filenm AS STRING * 14
   y1 AS INTEGER
   y2 AS INTEGER
   fx AS INTEGER
END TYPE

TYPE overlay
   x AS INTEGER
   y AS INTEGER
   tile AS INTEGER
   block AS INTEGER
END TYPE

TYPE autotalk
   x AS INTEGER
   y AS INTEGER
   filen AS STRING * 14
END TYPE


TYPE YellowDot
   curhit AS INTEGER
   maxhit AS INTEGER
   strth AS INTEGER
   accuracy AS INTEGER
   wisdom AS INTEGER
   luck AS INTEGER
END TYPE



 TYPE regtype
   ax AS INTEGER
   bx AS INTEGER
   cx AS INTEGER
   dx AS INTEGER
   bp AS INTEGER
   si AS INTEGER
   di AS INTEGER
  flags AS INTEGER
   ds AS INTEGER
   es AS INTEGER
 END TYPE

 TYPE DTAdata
   Reserved  AS STRING * 21
   Attribute AS STRING * 1
   FileTime  AS STRING * 2
   Filedate  AS STRING * 2
   FileSize  AS LONG
   FileName  AS STRING * 13
 END TYPE




DECLARE FUNCTION Exist% (Name$, SearchAttrb%)
DECLARE SUB BCircle (xc%, yc%, r%, c%, xval%, yval%)
DECLARE SUB credits ()
DECLARE SUB FadeIn (r%, G%, B%, Frames%, Part%, Low%, High%)
DECLARE SUB Fadeout (r%, G%, B%, Frames%, Part%, Low%, High%)
DECLARE SUB FadeoutM (r%, G%, B%, Frames%, Part%, Low%, High%)
DECLARE SUB getpal ()
DECLARE SUB delay (time%)
DECLARE SUB bprint (Layer%, Text$, x%, y%, Col%, col2%, typ%)
DECLARE SUB menu ()
DECLARE SUB drawscreen2 ()
DECLARE SUB mozaic (types%)
DECLARE SUB post ()
DECLARE SUB wavplay (file$)
DECLARE SUB TransBox (Layer%, x1%, y1%, x2%, y2%, colr%)
DECLARE FUNCTION MULTIKEY! (t!)
DECLARE FUNCTION ifunder% (a%)
DECLARE FUNCTION ifbehind! ()  'check for anything behind
DECLARE SUB checkforother ()   'check for warps and exits and such
DECLARE SUB scroll (direct!)   'the scrolling routine
DECLARE SUB CheckMidiTime ()   'checks midi time and restarts if nessesary
DECLARE FUNCTION input2$ (localx!, localy!, Col!, Length!)
DECLARE SUB BlastGet (dsegment%, doffset%, ssegment%, soffset%, x1%, y1%, x2%, y2%)
DECLARE SUB BlastPut (dsegment%, doffset%, ssegment%, soffset%, xpos%, ypos%, icol%)
DECLARE SUB BlastPset (Segment%, Offset%, xpos%, ypos%, Col%)
DECLARE FUNCTION BlastPoint% (Segment%, Offset%, xpos%, ypos%)
DECLARE SUB BlastCopy (fsegment%, foffset%, tsegment%, toffset%)
DECLARE SUB BlastScroll (fsegment%, foffset%, tsegment%, toffset%, xoffset%, yoffset%)
DECLARE SUB BlastCLS (Segment%, Offset%, Col%)
DECLARE SUB BlastPrint (Segment%, Offset%, xpos%, ypos%, Text$, Col%)
DECLARE SUB BlastLine (dsegment%, doffset%, x1%, y1%, x2%, y2%, colr%)
DECLARE SUB InitLib ()

DECLARE FUNCTION BytesRequired& (FileName$)
DECLARE SUB DriversLoaded (SBMIDI%, SBSIM%)
DECLARE SUB GetIntVector (IntNum%, Segment%, Offset%)
DECLARE SUB LoadAndPlayLarge (FileName$)
DECLARE SUB LoadAndPlayMIDI (FileName$, MIDISegment%, MIDIOffset%)
DECLARE SUB LoadLarge (FileName$)
DECLARE SUB LoadMIDI (FileName$, MIDISegment%, MIDIOffset%)
DECLARE FUNCTION MIDIError$ ()
DECLARE SUB PauseMIDI ()
DECLARE SUB ResumeMIDI ()
DECLARE SUB PlayLarge ()
DECLARE SUB PlayMIDI (MIDISegment%, MIDIOffset%)
DECLARE SUB StopMidi ()
DECLARE FUNCTION TimeMIDI! ()
DECLARE SUB checkforanim ()    'checks for still animation, this occurs again the the scroller.
DECLARE SUB talk (thefile$, wherex%, wherey%)  'the talking objects routine
DECLARE FUNCTION block% (tile%)  'detects if you're blocked by an object.
DECLARE SUB sprint (nowstring$, startx!, starty!, Col!, offsettype!, del!, threed!)   ' my printing routine
DECLARE SUB CheckTileDown ()     'checking the next time down
DECLARE SUB CheckTileRight ()     'checking the next time right
DECLARE SUB CheckTileLeft ()      'checking the next time left
DECLARE SUB CheckTileUp ()        'checking the next time up
DECLARE SUB LoadGraphics ()       'Load the Graphics
DECLARE SUB drawscreen ()         'Draw the still screen
DECLARE SUB OpenMap ()            'open map, get prelim info
DECLARE SUB LoadMap ()             ' Load all stuff into arrays.
DECLARE SUB Deftile (sure%)

DECLARE FUNCTION SpeakerStatus% ()
DECLARE FUNCTION DMAStatus% ()
DECLARE FUNCTION DMADone% ()
DECLARE FUNCTION ResetDSP% ()
DECLARE SUB FMVolume (RIGHT%, LEFT%, Getvol%)
DECLARE SUB VocVolume (RIGHT%, LEFT%, Getvol%)
DECLARE SUB MasterVolume (RIGHT%, LEFT%, Getvol%)
DECLARE SUB MicVolume (Gain%, Getvol%)
DECLARE SUB LineVolume (RIGHT%, LEFT%, Getvol%)
DECLARE SUB CDVolume (RIGHT%, LEFT%, Getvol%)
DECLARE SUB InputSource (InputSrc%, GetSrc%)
DECLARE SUB WriteDSP (byte%)
DECLARE SUB SetStereo (OnOff%)
DECLARE FUNCTION ReadDSP% ()
DECLARE SUB WriteDAC (byte%)
DECLARE SUB SpeakerState (OnOff%)
DECLARE SUB DMAState (StopGo%)
DECLARE FUNCTION ReadDAC% ()
DECLARE SUB DMAPlay (Segment&, Offset&, Length&, Freq&)
DECLARE SUB DMARecord (Segment&, Offset&, Length&, Freq&)
DECLARE SUB GetBLASTER (DMA%, BasePort%, IRQ%)
DECLARE FUNCTION DSPVersion! ()
DECLARE SUB wavplay (FileName$)

DECLARE FUNCTION DQBinit (BYVAL NumLayers, BYVAL NumSounds)
DECLARE FUNCTION DQBemsSeg ()
DECLARE FUNCTION DQBsetBit (BYVAL Value, BYVAL Bit)
DECLARE FUNCTION DQBresetBit (BYVAL Value, BYVAL Bit)
DECLARE FUNCTION DQBreadBit (BYVAL Value, BYVAL Bit)
DECLARE FUNCTION DQBtoggleBit (BYVAL Value, BYVAL Bit)
DECLARE FUNCTION DQBshiftLeft (BYVAL Value, BYVAL nBits)
DECLARE FUNCTION DQBshiftRight (BYVAL Value, BYVAL nBits)
DECLARE FUNCTION DQBpoint (BYVAL Layer, BYVAL x, BYVAL y)
DECLARE FUNCTION DQBsize (BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2)
DECLARE FUNCTION DQBfindCol (BYVAL Red, BYVAL Green, BYVAL Blue)
DECLARE FUNCTION DQBloadLayer (Layer AS INTEGER, FileName AS STRING, Pal AS STRING)
DECLARE FUNCTION DQBsaveLayer (Layer AS INTEGER, FileName AS STRING, Pal AS STRING, Format AS INTEGER)
DECLARE FUNCTION DQBkey (BYVAL ScanCode)
DECLARE FUNCTION DQBreadKey ()
DECLARE FUNCTION DQBjoyDetected (BYVAL JoyNum)
DECLARE FUNCTION DQBjoyMove (BYVAL JoyNum, BYVAL Direction)
DECLARE FUNCTION DQBjoyFire (BYVAL JoyNum, BYVAL Button)
DECLARE FUNCTION DQBmouseDetected ()
DECLARE FUNCTION DQBmouseX ()
DECLARE FUNCTION DQBmouseY ()
DECLARE FUNCTION DQBmouseLB ()
DECLARE FUNCTION DQBmouseRB ()
DECLARE FUNCTION DQBinstallSB (BaseAddr AS INTEGER, IRQ AS INTEGER, DMA AS INTEGER)
DECLARE FUNCTION DQBloadSound (Slot AS INTEGER, FileName AS STRING)
DECLARE SUB DQBcopyLayer (BYVAL SourceLayer, BYVAL DestLayer)
DECLARE SUB DQBcopyTransLayer (BYVAL SourceLayer, BYVAL DestLayer)
DECLARE SUB DQBclearLayer (BYVAL Layer)
DECLARE SUB DQBpset (BYVAL Layer, BYVAL x, BYVAL y, BYVAL Col)
DECLARE SUB DQBline (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL Col)
DECLARE SUB DQBbox (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL Col)
DECLARE SUB DQBboxf (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL Col)
DECLARE SUB DQBscroll (BYVAL Layer, BYVAL dx, BYVAL dy)
DECLARE SUB DQBwait (BYVAL Times)
DECLARE SUB DQBsetTransPut ()
DECLARE SUB DQBsetSolidPut ()
DECLARE SUB DQBsetClipBox (BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2)
DECLARE SUB DQBget (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2, BYVAL BufSeg, BYVAL BufOff)
DECLARE SUB DQBput (BYVAL Layer, BYVAL x, BYVAL y, BYVAL BufSeg, BYVAL BufOff)
DECLARE SUB DQBfastPut (BYVAL Layer, BYVAL x, BYVAL y, BYVAL BufSeg, BYVAL BufOff)
DECLARE SUB DQBscaledPut (BYVAL Layer, BYVAL x, BYVAL y, BYVAL BufSeg, BYVAL BufOff, BYVAL NewWidth, BYVAL NewHeight)
DECLARE SUB DQBsetCol (BYVAL ColorIndex, BYVAL Red, BYVAL Green, BYVAL Blue)
DECLARE SUB DQBgetCol (BYVAL ColorIndex, Red, Green, Blue)
DECLARE SUB DQBsetPal (Pal AS STRING)
DECLARE SUB DQBgetPal (Pal AS STRING)
DECLARE SUB DQBfadeIn (Pal AS STRING)
DECLARE SUB DQBfadeTo (BYVAL Red, BYVAL Green, BYVAL Blue)
DECLARE SUB DQBpalOff ()
DECLARE SUB DQBprint (Layer AS INTEGER, Text AS STRING, x AS INTEGER, y AS INTEGER, Col AS INTEGER)
DECLARE SUB DQBsetBIOSfont ()
DECLARE SUB DQBsetFont (Font AS STRING)
DECLARE SUB DQBsetTransText ()
DECLARE SUB DQBsetSolidText ()
DECLARE SUB DQBsetTextBackCol (BYVAL Col)
DECLARE SUB DQBinstallKeyboard ()
DECLARE SUB DQBwaitKey (BYVAL ScanCode)
DECLARE SUB DQBremoveKeyboard ()
DECLARE SUB DQBpollJoy (BYVAL JoyNum)
DECLARE SUB DQBresetJoy ()
DECLARE SUB DQBmouseShow ()
DECLARE SUB DQBmouseHide ()
DECLARE SUB DQBsetMouseRange (BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2)
DECLARE SUB DQBsetMouseShape (hotX AS INTEGER, hotY AS INTEGER, Shape AS STRING)
DECLARE SUB DQBresetMouse ()
DECLARE SUB DQBclose ()
DECLARE SUB DQBplaySound (BYVAL SoundNum, BYVAL Voice, BYVAL LoopFlag)
DECLARE SUB DQBsetVoiceVol (BYVAL Voice, BYVAL NewVol)
DECLARE SUB DQBstopVoice (BYVAL Voice)
DECLARE SUB DQBsetSamplingRate (Rate AS INTEGER)
DECLARE SUB DQBremoveSB ()
DECLARE SUB DQBsetVolume (BYVAL Volume)
DECLARE SUB DQBgpoly (BYVAL Layer, BYVAL x1, BYVAL y1, BYVAL c1, BYVAL x2, BYVAL y2, BYVAL c2, BYVAL x3, BYVAL y3, BYVAL c3)


COMMON SHARED BasePort%, LenPort%, Channel%, SBS%, SOUNDL%, SOUNDR%
COMMON SHARED NameMidi$, ppx%, ppy%, pmx%, pmy%, mapx%, mapy%, map$
COMMON SHARED xend%, xstart%, yend%, ystart%, filesave, noplayer%, allani%, ifblocked%
COMMON SHARED strtx%, strty%, colr%, ofst%, townname$, numwarp%, numtalk%, numexit%, numlay%, numautotalk%
COMMON SHARED playerpic%, LOADNEW%, ScrollSpeed%, moz%
COMMON SHARED try1%, try2%, try3%, try4%
COMMON SHARED code1%(), code2%(), code3%(), code4%(), code6%(), code7%(), code8%(), code9%()
COMMON SHARED buffer1%()
COMMON SHARED kbcontrol%(), kbmatrix%(), keyboardonflag%
COMMON SHARED map%(), totwarp() AS warptype, tottalk() AS talktype, totexit() AS exittype, totlay() AS overlay, totauto() AS autotalk
COMMON SHARED talkevents() AS INTEGER, MidiArray%()
COMMON SHARED SOUNDS%, SBSIM.INTERRUPT AS INTEGER
COMMON SHARED MIDI.PLAYTIME AS SINGLE, MIDI.ERROR AS INTEGER
COMMON SHARED MIDI.LOADED AS INTEGER, SBMIDI.INTERRUPT AS INTEGER
COMMON SHARED dot() AS YellowDot, bluepal%(), redpal%(), Pal() AS STRING * 1
COMMON SHARED numblock%, numhurt%, numunder%, btile%(), htile%(), utile%()
COMMON SHARED DEBUG%, wavarray() AS STRING * 32767
COMMON SHARED ISGOOD%, pmx2%, pmy2%, MapFX%, EXITGAME%, GAMEFONT$


CONST offsets% = 118
CONST VIDEO = 0, BUF = 2, BSV = 0, BMP = 1, PCX = 2
CONST KEYESC = 1, KEYENTER = 28, KEYSPACE = 57
CONST KEYUP = 72, KEYDOWN = 80, KEYLEFT = 75, KEYRIGHT = 77
CONST UP = 0, DOWN = 1, LEFT = 2, RIGHT = 3
CONST JOY1 = 0, JOY2 = 1, BUTA = 0, BUTB = 1
CONST AUTO = -1, ONCE = 0, LOOPED = 1

